/************************************************************************************************
 * Copyright  (c) 2011, 2012, 2013 University of Pennsylvania
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose, without fee, and without a
 * written agreement is hereby granted, provided that the above copyright
 * notice and this paragraph and the following two paragraphs appear in
 * all copies.
 *
 * IN NO EVENT SHALL THE UNIVERSITY OF PENNSYLVANIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF PENNSYLVANIA
 * HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * THE UNIVERSITY OF PENNSYLVANIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS ON
 * AN "AS IS" BASIS, AND THE UNIVERSITY OF PENNSYLVANIA HAS NO OBLIGATIONS TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 ***********************************************************************************************/

/****************************************************
Test Bench

Author: Udit Dhawan
	IC Group, University of Pennsylvania

*****************************************************/


package Test;

import Wrapper::*;

module mkTest(Empty);

	WrapperIfc dmhc_wrapper <- mkWrapper;

	Reg#(Bit#(32)) cycle <- mkReg(0);
	Reg#(Bit#(64)) key <- mkReg(1);


	rule inc_cycle;
		cycle <= cycle + 1;
	endrule

	rule this_is_end (cycle == 32768);
		$finish();
	endrule

	rule give_key(cycle%1000 == 0);
		let success <- dmhc_wrapper.lookup_key(unpack(pack(key)));
		if(!success) begin
			$display("key lookup failed");
		end
	endrule

	rule get_value(cycle%1002 == 0);
		let hit = dmhc_wrapper.is_hit;
		if(hit) begin
			$display("hit");
			let value = dmhc_wrapper.get_value;
			$display("value: %d", value); 
		end
		else begin
			$display("miss");
			dmhc_wrapper.new_key_value(unpack(pack(key)), unpack(pack(key)));
			key <= key<<2;
		end
	endrule

endmodule: mkTest

endpackage
